use anyhow::Result;

use super::{syntax, ContentType};

#[derive(Debug)]
pub struct Content {
	systems: Vec<syntax::System>,
}

impl Content {
	pub fn new(cv: Vec<ContentType>) -> Result<Self> {
		let mut content = Self {
			systems: Vec::new(),
		};

		// TODO: locate bad files

		// These methods check intra-file consistency
		for c in cv {
			match c {
				ContentType::System(v) => content.add_system(v)?,
			};
		}

		return Ok(content);
	}

	fn add_system(&mut self, toml: syntax::system::toml::SystemRoot) -> Result<()> {
		self.systems.push(syntax::System::parse(toml)?);
		return Ok(());
	}
}
