use anyhow::Result;
use std::{fs::File, io::Read, path::Path};

use super::syntax;

#[derive(Debug)]
pub enum ContentType {
	System(syntax::system::toml::SystemRoot),
}

// TODO: check content without loading game
impl ContentType {
	pub fn try_parse(file_string: &str) -> Result<Option<Self>> {
		// TODO: More advanced parsing, read the whole top comment
		let (first, _) = file_string.split_once("\n").unwrap();
		let type_spec = first[1..].trim(); // Remove hash

		return Ok(match type_spec {
			"content type: system" => Some(Self::System(toml::from_str(&file_string)?)),
			_ => None,
		});
	}

	pub fn from_path(path: &Path) -> Result<Option<Self>> {
		let mut file_string = String::new();
		let _ = File::open(path)?.read_to_string(&mut file_string);
		let file_string = file_string.trim();
		return Self::try_parse(&file_string);
	}
}
