use cgmath::{Deg, Point2};

use crate::{physics::Pfloat, render::SpriteTexture, Sprite, Spriteable};

pub struct Doodad {
	pub sprite: SpriteTexture,
	pub pos: Point2<Pfloat>,
	pub parallax: Pfloat,
	pub size: Pfloat,
}

impl Spriteable for Doodad {
	fn get_sprite(&self) -> Sprite {
		return Sprite {
			texture: self.sprite.clone(),
			pos: self.pos,
			angle: Deg(0.0),
			scale: 1.0,
			size: self.size,
			parallax: self.parallax,
		};
	}
}
